︠98da64ca-b484-4c05-a910-49bbc2461b38s︠
reset()
pretty_print_default(True)
︡a9cf7772-5054-41cd-a9a4-f7082a9a0b9f︡{"done":true}︡
︠69e05f81-031f-425d-a10a-2e4f65c52eces︠
M = Manifold(4, 'M')
︡908d8177-f71c-41f2-93c1-cdef7d2b09d4︡{"done":true}︡
︠e25fe242-7a4c-4c8a-9e74-603ece3eaaa4s︠
print M
︡c95d77b7-9eef-48d4-9deb-3d24d4ab5032︡{"stdout":"4-dimensional differentiable manifold M\n"}︡{"done":true}︡
︠caabaf84-23a2-4bab-8e3a-7dd6ca2e9be4s︠
fr.<t,x,y,z> = M.chart('t:(-oo,+oo) x:(-oo,+oo) y:(-oo,+oo) z:(-oo,+oo)')
fr
︡2a4fa60d-df44-4e35-be79-5dd30052ee4a︡{"html":"<div align='center'>$\\displaystyle \\left(M,(t, x, y, z)\\right)$</div>"}︡{"done":true}︡
︠b55eb0bc-d675-49df-9ac8-5cb16b2a1bb7s︠
s      = var('s', domain='positive')
Lambda = var('Lambda', domain='positive')
k      = var('k', domain='integer')
epsilon = var('epsilon')

a = M.scalar_field(function('a')(t), name='a')
b = M.scalar_field(function('b')(t), name='b')
rho = M.scalar_field(function('rho')(t), name='rho')
︡7649d73c-df3c-41cb-a5b4-ed9742a40451︡{"done":true}︡
︠b25cea95-4183-454d-b90d-e583ab3eda7as︠
g = M.lorentz_metric('g')

g[0,0] = -1
g[1,1] = a^2
g[2,2] = a^2
g[3,3] = a^2

g.display()
︡ac2a55c3-e3d2-4ed9-b201-709d92d001bf︡{"stderr":"<string>:1: DeprecationWarning: Use lorentzian_metric() instead.\nSee http://trac.sagemath.org/19209 for details.\n"}︡{"html":"<div align='center'>$\\displaystyle g = -\\mathrm{d} t\\otimes \\mathrm{d} t + a\\left(t\\right)^{2} \\mathrm{d} x\\otimes \\mathrm{d} x + a\\left(t\\right)^{2} \\mathrm{d} y\\otimes \\mathrm{d} y + a\\left(t\\right)^{2} \\mathrm{d} z\\otimes \\mathrm{d} z$</div>"}︡{"done":true}︡
︠2249b838-dd43-4b00-8d37-a9708c0baad8s︠
gamma = M.tensor_field(0,2)

g00 = M.scalar_field(function('g00')(t, x, y, z), latex_name='\gamma_{00}')
g11 = M.scalar_field(function('g11')(t, x, y, z), latex_name='\gamma_{11}')
g22 = M.scalar_field(function('g22')(t, x, y, z), latex_name='\gamma_{22}')
g33 = M.scalar_field(function('g33')(t, x, y, z), latex_name='\gamma_{33}')

gamma[0,0] = g00
gamma[1,1] = g11
gamma[2,2] = g22
gamma[3,3] = g33
︡7ad652fd-ae49-47a0-b272-39d9d0bd2a6b︡{"done":true}︡
︠853b2a26-01cb-4957-971f-712ae15d59eds︠
G = g + epsilon*gamma
G.display()
︡9ba723cf-6d33-4c98-93ba-31bca716f535︡{"html":"<div align='center'>$\\displaystyle \\left( \\epsilon g_{00}\\left(t, x, y, z\\right) - 1 \\right) \\mathrm{d} t\\otimes \\mathrm{d} t + \\left( a\\left(t\\right)^{2} + \\epsilon g_{11}\\left(t, x, y, z\\right) \\right) \\mathrm{d} x\\otimes \\mathrm{d} x + \\left( a\\left(t\\right)^{2} + \\epsilon g_{22}\\left(t, x, y, z\\right) \\right) \\mathrm{d} y\\otimes \\mathrm{d} y + \\left( a\\left(t\\right)^{2} + \\epsilon g_{33}\\left(t, x, y, z\\right) \\right) \\mathrm{d} z\\otimes \\mathrm{d} z$</div>"}︡{"done":true}︡
︠93db6975-fea5-4d97-98b4-08f7a9d84c3bs︠
Gup = g.up(g) - epsilon*gamma.up(g)
Gup.display()
︡8cf5307f-c64b-439d-af4b-535a3a62b590︡{"html":"<div align='center'>$\\displaystyle \\left( -\\epsilon g_{00}\\left(t, x, y, z\\right) - 1 \\right) \\frac{\\partial}{\\partial t }\\otimes \\frac{\\partial}{\\partial t } + \\left( \\frac{a\\left(t\\right)^{2} - \\epsilon g_{11}\\left(t, x, y, z\\right)}{a\\left(t\\right)^{4}} \\right) \\frac{\\partial}{\\partial x }\\otimes \\frac{\\partial}{\\partial x } + \\left( \\frac{a\\left(t\\right)^{2} - \\epsilon g_{22}\\left(t, x, y, z\\right)}{a\\left(t\\right)^{4}} \\right) \\frac{\\partial}{\\partial y }\\otimes \\frac{\\partial}{\\partial y } + \\left( \\frac{a\\left(t\\right)^{2} - \\epsilon g_{33}\\left(t, x, y, z\\right)}{a\\left(t\\right)^{4}} \\right) \\frac{\\partial}{\\partial z }\\otimes \\frac{\\partial}{\\partial z }$</div>"}︡{"done":true}︡
︠4ea5d813-4c0f-427b-93cd-57e6ccefc048s︠
nabla = g.connection()
print nabla ; nabla
︡1a2241b1-ae97-46ef-be98-7765aad984eb︡{"stdout":"Levi-Civita connection nabla_g associated with the Lorentzian metric g on the 4-dimensional differentiable manifold M\n"}︡{"html":"<div align='center'>$\\displaystyle \\nabla_{g}$</div>"}︡{"done":true}︡
︠8c69f7a3-804e-424d-8bb1-646eab1799dbs︠
Ricci = nabla.ricci()
print Ricci ; Ricci
︡7d27266b-589d-4210-a9e9-6b93712a3b9d︡{"stdout":"Field of symmetric bilinear forms Ric(g) on the 4-dimensional differentiable manifold M\n"}︡{"html":"<div align='center'>$\\displaystyle \\mathrm{Ric}\\left(g\\right)$</div>"}︡{"done":true}︡
︠9f1a2ba7-e263-4a58-97b4-141bdbf9c9f8s︠
Ricci_scalar = g.ricci_scalar()
Ricci_scalar.display()
︡c1b7877c-b79d-4af9-9d40-563e43183032︡{"html":"<div align='center'>$\\displaystyle \\begin{array}{llcl} \\mathrm{r}\\left(g\\right):&amp; M &amp; \\longrightarrow &amp; \\mathbb{R} \\\\ &amp; \\left(t, x, y, z\\right) &amp; \\longmapsto &amp; \\frac{6 \\, {\\left(\\left(\\frac{\\partial\\,a}{\\partial t}\\right)^{2} + a\\left(t\\right) \\frac{\\partial^2\\,a}{\\partial t^2}\\right)}}{a\\left(t\\right)^{2}} \\end{array}$</div>"}︡{"done":true}︡
︠8dfb0b3d-9569-456d-b48d-1adac1f7135cs︠
aux = nabla(G)
aux[0,0,1].display()
︡9d4053f3-3967-495a-90ac-89183eca72c1︡{"html":"<div align='center'>$\\displaystyle \\left(t, x, y, z\\right) \\mapsto \\epsilon \\frac{\\partial\\,g_{00}}{\\partial x}$</div>"}︡{"done":true}︡
︠db4da76d-22b3-4fb3-8b0c-e5b5548472f2s︠

C = (1/2)*Gup['^{cd}']*aux['_{dab}'] + (1/2)*Gup['^{cd}']*aux['_{bda}'] - (1/2)*Gup['^{cd}']*aux['_{abd}']
︡84613bf5-7398-4a73-8d8b-844bbcce2a10︡{"done":true}︡
︠8a8448e7-2b81-4685-aba1-9bd133370c3fs︠
B = M.vector_field('B')
B[0] = -b
B.display()
︡9fc5d2f4-d219-4a99-9bbf-1d9fa558bb44︡{"html":"<div align='center'>$\\displaystyle B = -b\\left(t\\right) \\frac{\\partial}{\\partial t }$</div>"}︡{"done":true}︡
︠471af1db-cab6-4bff-ac05-ddd4352fdfb7︠

︡768439d5-7918-40ba-a0a7-a8fffd012f64︡
︠269939bc-b122-4bb7-8f18-c6dd6da018bbs︠
B_form = B.down(g) # the 1-form associated to B by metric duality
B_form.display()
︡17c8e78c-2b47-43f5-9b43-61d3a9a39bbc︡{"html":"<div align='center'>$\\displaystyle b\\left(t\\right) \\mathrm{d} t$</div>"}︡{"done":true}︡
︠e05a6c3f-7af1-4da5-9693-264b0c4cfa72s︠
T01ab = nabla(B*B) + C['^{c}_{ab}']*B['^{a}']*B + C['^{c}_{ab}']*B['^{b}']*B
︡e31e6d2d-82a6-4e16-9355-77eab15daefc︡{"done":true}︡
︠0e20eeb8-dce3-4618-af83-f347079f978fs︠
T01 = lim(derivative(T01ab,epsilon),epsilon=0)
︡39462273-9113-48df-a764-95042f57625c︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-6.10/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 942, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"/projects/sage/sage-6.10/local/lib/python2.7/site-packages/sage/calculus/functional.py\", line 134, in derivative\n    f = SR(f)\n  File \"sage/structure/parent.pyx\", line 1111, in sage.structure.parent.Parent.__call__ (/projects/sage/sage-6.10/src/build/cythonized/sage/structure/parent.c:9821)\n    return mor._call_(x)\n  File \"sage/structure/coerce_maps.pyx\", line 109, in sage.structure.coerce_maps.DefaultConvertMap_unique._call_ (/projects/sage/sage-6.10/src/build/cythonized/sage/structure/coerce_maps.c:4542)\n    raise\n"}︡{"stderr":"  File \"sage/structure/coerce_maps.pyx\", line 104, in sage.structure.coerce_maps.DefaultConvertMap_unique._call_ (/projects/sage/sage-6.10/src/build/cythonized/sage/structure/coerce_maps.c:4426)\n    return C._element_constructor(x)\n  File \"sage/symbolic/ring.pyx\", line 314, in sage.symbolic.ring.SymbolicRing._element_constructor_ (/projects/sage/sage-6.10/src/build/cythonized/sage/symbolic/ring.cpp:6299)\n    raise TypeError\nTypeError\n"}︡{"done":true}︡
︠b196e6c2-2957-422b-aea3-18f226acdcd9s︠
︡f14248d6-8052-42c8-9957-130c6327c4e9︡{"done":true}︡
︠128de7c1-6b6b-4426-9274-c1396ac347cbs︠
derivative(T01ab,epsilon)
︡deebd762-45eb-454c-9874-82d7d6ef3b0f︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-6.10/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 942, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"/projects/sage/sage-6.10/local/lib/python2.7/site-packages/sage/calculus/functional.py\", line 134, in derivative\n    f = SR(f)\n  File \"sage/structure/parent.pyx\", line 1111, in sage.structure.parent.Parent.__call__ (/projects/sage/sage-6.10/src/build/cythonized/sage/structure/parent.c:9821)\n    return mor._call_(x)\n  File \"sage/structure/coerce_maps.pyx\", line 109, in sage.structure.coerce_maps.DefaultConvertMap_unique._call_ (/projects/sage/sage-6.10/src/build/cythonized/sage/structure/coerce_maps.c:4542)\n    raise\n  File \"sage/structure/coerce_maps.pyx\", line 104, in sage.structure.coerce_maps.DefaultConvertMap_unique._call_ (/projects/sage/sage-6.10/src/build/cythonized/sage/structure/coerce_maps.c:4426)\n    return C._element_constructor(x)\n  File \"sage/symbolic/ring.pyx\", line 314, in sage.symbolic.ring.SymbolicRing._element_constructor_ (/projects/sage/sage-6.10/src/build/cythonized/sage/symbolic/ring.cpp:6299)\n    raise TypeError\nTypeError\n"}︡{"done":true}︡
︠63acc081-42f7-4e53-a638-8b2e36baf77d︠









